<template>
  <div class="tenant">
    <!-- <Banner /> -->
    <div class="content">
      <byTable
        :source="sourceList.data"
        :pagination="sourceList.pagination"
        :config="config"
        :loading="loading"
        highlight-current-row
        :selectConfig="selectConfig"
        :table-events="{
          //element talbe事件都能传
          select: select,
        }"
        :action-list="[
          {
            text: '添加工艺',
            action: () => openModal('add'),
          },
        ]"
        @get-list="getList"
      >
        <template #line="{ item }">
          <span v-for="(x, i) in item.processRouteNameList" :key="i">
            {{ x }}
            <span
              style="margin: 0 3px"
              v-if="i + 1 < item.processRouteNameList.length"
              >>
            </span>
          </span>
        </template>
        <template #product="{ item }">
          <span v-for="(x, i) in item.applicableProductsNameList" :key="i">
            {{ x }}
            <span v-if="i + 1 < item.applicableProductsNameList.length"
              >,
            </span>
          </span>
        </template>
      </byTable>
    </div>
    <el-dialog
      :title="modalType == 'add' ? '添加工艺' : '编辑工艺'"
      v-model="dialogVisible"
      width="650"
      v-loading="loading"
    >
      <byForm
        :formConfig="formConfig"
        :formOption="formOption"
        v-model="formData.data"
        :rules="rules"
        ref="byform"
      >
        <template #lineSlot>
          <el-transfer
            v-model="selectLine"
            filterable
            filter-placeholder="搜索"
            :data="lineData"
            :titles="['可选', '已选']"
            target-order="push"
          >
            <template #default="{ option }">
              <div class="parent">
                <!-- 只有选择的数据才能拖拽 -->
                <div
                  :draggable="selectLine.includes(option.key)"
                  @dragstart="dragStar($event, option)"
                  @dragover="dragOver($event, option)"
                  @drop="handleDrop($event)"
                  style="cursor: default"
                  :id="option.key"
                >
                  {{ option.label }}
                </div>
              </div>
            </template>
          </el-transfer>
        </template>
        <template #productSlot>
          <div>
            <el-button type="primary" @click="openProduct = true">
              添加产品
            </el-button>
            <div style="margin-top: 15px">
              <el-tag
                style="margin-right: 10px"
                type="info"
                closable
                v-for="(product, index) in productList"
                :key="product.id"
                @close="handleRemove(index)"
                >{{ product.name }}</el-tag
              >
            </div>
          </div>
        </template>
      </byForm>
      <template #footer>
        <el-button @click="dialogVisible = false" size="large">取 消</el-button>
        <el-button
          type="primary"
          @click="submitForm('byform')"
          size="large"
          :loading="submitLoading"
        >
          确 定
        </el-button>
      </template>
    </el-dialog>
    <el-dialog
      v-model="openProduct"
      title="选择产品"
      width="70%"
      append-to-body
    >
      <SelectProduct @handleSelect="handleSelect"></SelectProduct>
      <template #footer>
        <span class="dialog-footer">
          <el-button @click="openProduct = false">取消</el-button>
        </span>
      </template>
    </el-dialog>
  </div>
</template>
  
<script setup>
/* eslint-disable vue/no-unused-components */
import { ElMessage, ElMessageBox } from "element-plus";
import byTable from "@/components/byTable/index";
import byForm from "@/components/byForm/index";
import SelectProduct from "@/components/product/SelectProduct";

import { computed, defineComponent, ref, toRaw } from "vue";
const loading = ref(false);
const submitLoading = ref(false);
const sourceList = ref({
  data: [],
  pagination: {
    total: 3,
    pageNum: 1,
    pageSize: 10,
  },
});
let lineData = ref([
  {
    key: "1",
    label: "测试1",
    disabled: false,
  },
  {
    key: "2",
    label: "测试2",
    disabled: false,
  },
  {
    key: "3",
    label: "测试3",
    disabled: false,
  },
  {
    key: "4",
    label: "测试4",
    disabled: false,
  },
]);
let selectLine = ref([]);
let dialogVisible = ref(false);
let openProduct = ref(false);
let modalType = ref("add");
let rules = ref({
  name: [{ required: true, message: "请输入工艺名称", trigger: "blur" }],
});
const { proxy } = getCurrentInstance();
const selectConfig = reactive([
  // {
  //   label: "车间类型",
  //   prop: "type",
  //   data: [
  //     {
  //       label: "普通车间",
  //       value: "1",
  //     },
  //     {
  //       label: "半自动化车间",
  //       value: "2",
  //     },
  //     {
  //       label: "自动化车间",
  //       value: "3",
  //     },
  //   ],
  // },
]);
const config = computed(() => {
  return [
    {
      attrs: {
        label: "工艺名称",
        prop: "name",
        width: 150,
      },
    },

    {
      attrs: {
        label: "工艺路线",

        slot: "line",
      },
    },
    {
      attrs: {
        label: "适用产品",

        slot: "product",
      },
    },
    {
      attrs: {
        label: "工艺说明",
        prop: "remarks",
      },
    },
    {
      attrs: {
        label: "操作",
        width: "200",
        align: "right",
      },
      // 渲染 el-button，一般用在最后一列。
      renderHTML(row) {
        return [
          {
            attrs: {
              label: "修改",
              type: "primary",
              text: true,
            },
            el: "button",
            click() {
              getDtl(row);
            },
          },
          {
            attrs: {
              label: "删除",
              type: "danger",
              text: true,
            },
            el: "button",
            click() {
              // 弹窗提示是否删除
              ElMessageBox.confirm(
                "此操作将永久删除该数据, 是否继续?",
                "提示",
                {
                  confirmButtonText: "确定",
                  cancelButtonText: "取消",
                  type: "warning",
                }
              ).then(() => {
                // 删除
                proxy
                  .post("/technology/delete", {
                    id: row.id,
                  })
                  .then((res) => {
                    ElMessage({
                      message: "删除成功",
                      type: "success",
                    });
                    getList();
                  });
              });
            },
          },
        ];
      },
    },
  ];
});

let formData = reactive({
  data: {
    name: "",
    processRouteList: [],
    remarks: "",
    productList: [],
  },
});
const formOption = reactive({
  inline: true,
  labelWidth: 100,
  itemWidth: 100,
  rules: [],
});
const byform = ref(null);
const formConfig = computed(() => {
  return [
    {
      type: "input",
      prop: "name",
      label: "工艺名称",
      required: true,
    },
    {
      type: "slot",
      slotName: "lineSlot",
      label: "工艺路线",
    },
    {
      type: "slot",
      slotName: "productSlot",
      label: "适用产品",
    },
    {
      type: "input",
      prop: "remarks",
      label: "工艺说明",
      itemType: "textarea",
    },
  ];
});
const getList = async (req) => {
  sourceList.value.pagination = { ...sourceList.value.pagination, ...req };
  loading.value = true;
  proxy
    .post("/technology/page", sourceList.value.pagination)
    .then((message) => {
      console.log(message);
      sourceList.value.data = message.rows;
      sourceList.value.pagination.total = message.total;
      setTimeout(() => {
        loading.value = false;
      }, 200);
    });
};
const getProcesses = async () => {
  proxy
    .post("/productionProcesses/page", { pageNum: 1, pageSize: 9999 })
    .then((message) => {
      lineData.value = message.rows.map((x) => ({
        key: x.id,
        label: x.name,
        disabled: false,
      }));
    });
};
const openModal = () => {
  dialogVisible.value = true;
  modalType.value = "add";
  formData.data = {};
  selectLine.value = [];
  productList.value = [];
};

const submitForm = () => {
  byform.value.handleSubmit((valid) => {
    if (!selectLine.value.length > 0)
      return ElMessage({
        message: "请添加工艺路线",
        type: "info",
      });
    if (!productList.value.length > 0)
      return ElMessage({
        message: "请添加适用产品",
        type: "info",
      });
    submitLoading.value = true;
    formData.data.processRouteList = selectLine.value; //选择的工序数据
    formData.data.productList = productList.value.map((x) => ({
      productId: x.id,
    })); //选择的产品数据
    proxy.post("/technology/" + modalType.value, formData.data).then(
      (res) => {
        ElMessage({
          message: modalType.value == "add" ? "添加成功" : "编辑成功",
          type: "success",
        });
        dialogVisible.value = false;
        submitLoading.value = false;

        getList();
      },
      (err) => {
        console.log(err, "aswwwww");
        submitLoading.value = false;
      }
    );
  });
};

const getDtl = (row) => {
  modalType.value = "edit";
  proxy.post("/technology/detail", { id: row.id }).then((res) => {
    productList.value = res.applicableProductsList;
    selectLine.value = res.processRouteList.map((x) => x.id);
    formData.data = res;
    dialogVisible.value = true;
  });
};

const productList = ref([]);

const handleSelect = (row) => {
  const flag = productList.value.some((x) => x.id === row.id);
  if (flag)
    return ElMessage({
      message: "该产品已选择",
      type: "info",
    });
  productList.value.push(row);
  return ElMessage({
    message: "选择成功",
    type: "success",
  });
};

const handleRemove = (index) => {
  productList.value.splice(index, 1);
  return ElMessage({
    message: "删除成功",
    type: "success",
  });
};

getList();
getProcesses();
// 以下是实现拖拽排序的处理方法
const dragStar = (e, option) => {
  // if (!selectLine.value.includes(e.target.id)) return; //拖拽的数据如不是选择的数据直接return
  e.dataTransfer.setData("text/plain", option.key);
  e.dataTransfer.effectAllowed = "move";
  e.dataTransfer.dropEffect = "move";
};

const dragOver = (e, option) => {
  e.preventDefault();
};

const handleDrop = (e) => {
  // if (!selectLine.value.includes(e.target.id)) return; //拖拽的数据如不是选择的数据直接return
  e.preventDefault();
  const sourceKey = e.dataTransfer.getData("text/plain"); //获取拖动元素的key值
  const targetKey = e.target.id; //获取被互换元素的id值
  swapItems(sourceKey, targetKey);
};

// const findIndex = (target) => {
//   while (target && target.parentNode) {
//     let targetParent = target.parentNode;
//     const index = Array.from(targetParent.children).indexOf(target);
//     if (index !== -1) {
//       return index;
//     }
//   }
//   return -1;
// };

// 调换数据源位置
const swapItems = (sourceKey, targetKey) => {
  const sourceIndex = selectLine.value.findIndex((x) => x === sourceKey);
  const targetIndex = selectLine.value.findIndex((x) => x === targetKey);
  const temp = selectLine.value[sourceIndex];
  selectLine.value[sourceIndex] = selectLine.value[targetIndex];
  selectLine.value[targetIndex] = temp;
};
</script>
  
<style lang="scss" scoped>
.tenant {
  padding: 20px;
}
</style>